﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using MPS;
using System.Runtime.InteropServices;


namespace TestI2C
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            mmtimer = new TMultimediaTimer(null);
            mmtimer.Interval = 100;
            mmtimer.OnTimer = mmtimerTick;
            
        }

        TMultimediaTimer mmtimer;

        [DllImport("ch341dll.DLL",CallingConvention=CallingConvention.Winapi)]
        public extern static long CH341OpenDevice(int i);

        [DllImport("ch341dll.DLL",CallingConvention=CallingConvention.Winapi)]
        public extern static void CH341CloseDevice(int iIndex);

        // CH341WriteI2C( ULONG iIndex, UCHAR iDevice, UCHAR iAddr, UCHAR iByte );
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static bool CH341WriteI2C(int iIndex,byte i1,byte i2, byte i3);
        // Calling convention: Cdecl geht nicht, PInvokeStackImbalance- Fehler
        //.FastCall :Ungültige nicht verwaltete Aufrufkonvention ("stdcall", "cdecl" oder "thiscall" ist erforderlich). 
        // .stdCall : OK
        // .ThisCall :  PInvokeStackImbalance- Fehler
        // .WinApi : OK

        // CH341StreamI2C(ChipIndex.Value,wlen,@outbytes,rlen,@inbytes); 
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.StdCall)]
        public extern static bool CH341StreamI2C(int iIndex, int wlen, ref byte WBuf, int rlen, ref byte RBuf);


        // CH341SetStream() konfiguriert I2C und SPI
        // Bit 1-0: I2C speed 00= low speed /20KHz
        // 01= standard /100KHz
        // 10= fast /400KHz
        // 11= high speed /750KHz           plus  0x60  , das ist wichtig. Also :
        // BOOL	WINAPI	CH341SetStream( ULONG iIndex, ULONG	iMode );*/
 
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static long CH341SetStream(int iIndex, int iMode);

        byte[] WriteBuf = new byte[10];
        byte[] ReadBuf = new byte[10];

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            long open = CH341OpenDevice(0);
            if (open != 4294967295)   // if chip not connected open is Hex 00000000FFFFFFFF
            {
                label2.Text = "Chip is open with adress " + open.ToString("X16");
            }
            else label2.Text = "No Chip could be opened";


        }

         private void butStart1secTimer_Click(object sender, EventArgs e)
        {
            if (timer2.Enabled)
                timer2.Enabled = false;
            else
            {
                butInitTempADC_Click(null, null);
                timer2.Enabled = true;
            }
        }

 
         private void buttonClose_Click(object sender, EventArgs e)
        {
            label2.Text = " No Chip open";
            
            mmtimer.Disable();
            CH341CloseDevice(0);

        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBox2.Clear();
        }

        private void buttonClearTB1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            byte[] LED = new byte[10];
            LED[0] = Convert.ToByte( "3F",16); LED[1] = Convert.ToByte("06",16); LED[2] =Convert.ToByte("5B",16); 
            LED[3] = Convert.ToByte("4F",16); LED[4] =Convert.ToByte("66",16);
            LED[5] = Convert.ToByte("6D",16); LED[6] = Convert.ToByte("7D",16); LED[7] = Convert.ToByte("07",16); 
            LED[8] = Convert.ToByte("7F",16); LED[9] = Convert.ToByte("6F",16);
            byte[] LEDp = new byte[10];
            LEDp[0] = Convert.ToByte("BF",16); LEDp[1] = Convert.ToByte("86",16); LEDp[2] = Convert.ToByte("DB",16); 
            LEDp[3] = Convert.ToByte("CF",16); LEDp[4] = Convert.ToByte("E6",16);
            LEDp[5] = Convert.ToByte("ED", 16); LEDp[6] = Convert.ToByte("FD", 16); LEDp[7] = Convert.ToByte("87", 16); 
            LEDp[8] = Convert.ToByte("FF",16); LEDp[9] = Convert.ToByte("EF",16);
 

            // read Temp. - Sensor
            WriteBuf[0] = Convert.ToByte("91", 16);
            WriteBuf[1] = Convert.ToByte("02", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
            
            sbyte high = (sbyte)ReadBuf[0];
            short low = ReadBuf[1];
            labTemp.Text = (high + low / 256.0).ToString("f2") + "°";

            
            // Read ADC
            

            textBox2.Text = label9.Text;  // read ADC
            WriteBuf[0] = Convert.ToByte("93", 16);
            WriteBuf[1] = Convert.ToByte("02", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
            textBox1.Clear();
            textBox1.Text = ReadBuf[0].ToString("x2") + " " + ReadBuf[1].ToString("x2");
            high = (sbyte)ReadBuf[0];
            mvolt = high * 32 + ReadBuf[1] / 32;
            //int mVoutcorr = mvolt * 4095 / (int)numericUpDown3.Value;
            labADCOut.Text = mvolt.ToString("f3") + " V";

            // Write to 4 * 7 Seg ELV- Display
            int mvt = mvolt / 1000;
            int rest = mvolt - mvt * 1000;
            int mvh = rest / 100;
            rest=rest -mvh * 100;
            int mvz = rest / 10;
            int mve = rest - mvz * 10;
            WriteBuf[0] = Convert.ToByte("70", 16);
            WriteBuf[1] = Convert.ToByte("00", 16);
            WriteBuf[2] = Convert.ToByte("17", 16);
            WriteBuf[3] = LEDp[mvt];
            WriteBuf[4] = LED[mvh];
            WriteBuf[5] = LED[mvz];
            WriteBuf[6] = LED[mve];
            CH341StreamI2C(0, 7, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }

        int mvolt = 0;



        private void label3_Click(object sender, EventArgs e)
        {
            textBox2.Text = label3.Text;  // Ausgabe "1234" auf 4 * 7 Seg
            WriteBuf[0] = Convert.ToByte("70", 16);
            WriteBuf[1] = Convert.ToByte("00", 16);
            WriteBuf[2] = Convert.ToByte("17", 16);
            WriteBuf[3] = Convert.ToByte("06", 16);
            WriteBuf[4] = Convert.ToByte("5b", 16);
            WriteBuf[5] = Convert.ToByte("4f", 16);
            WriteBuf[6] = Convert.ToByte("66", 16);
            CH341StreamI2C(0, 7, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }

        private void label4_Click(object sender, EventArgs e)
        {
            textBox2.Text = label4.Text;  // Init Temp.- Sensor
            WriteBuf[0] = Convert.ToByte("90", 16);
            WriteBuf[1] = Convert.ToByte("01", 16);
            WriteBuf[2] = Convert.ToByte("60", 16);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }

        private void label5_Click(object sender, EventArgs e)
        {
            textBox2.Text = label5.Text;  // Temp auf Conversion
            WriteBuf[0] = Convert.ToByte("90", 16);
            WriteBuf[1] = Convert.ToByte("00", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);
        }

        private void label6_Click(object sender, EventArgs e)
        {
            textBox2.Text = label6.Text;  // Read Temp
            WriteBuf[0] = Convert.ToByte("91", 16);
            WriteBuf[1] = Convert.ToByte("02", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
            textBox1.Clear();
            textBox1.Text = ReadBuf[0].ToString("x2") + " " + ReadBuf[1].ToString("x2") ;
            sbyte high = (sbyte)ReadBuf[0];
            short low = ReadBuf[1];
            labTemp.Text = (high + low / 256.0).ToString("f2") + "°";

        }

        private void label7_Click(object sender, EventArgs e)
        {
            textBox2.Text = label7.Text;
            // Init ADC
            WriteBuf[0] = Convert.ToByte("92", 16);
            WriteBuf[1] = Convert.ToByte("01", 16);
            WriteBuf[2] = Convert.ToByte("42", 16);
            WriteBuf[3] = Convert.ToByte("e3", 16);
            CH341StreamI2C(0, 4, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }

        private void label8_Click(object sender, EventArgs e)
        {
            textBox2.Text = label8.Text;  // Adc on Conversion pointer
            WriteBuf[0] = Convert.ToByte("92", 16);
            WriteBuf[1] = Convert.ToByte("00", 16);
             CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }

        private void label9_Click(object sender, EventArgs e)
        {
            sbyte high;

            textBox2.Text = label9.Text;  // read ADC
            WriteBuf[0] = Convert.ToByte("93", 16);
            WriteBuf[1] = Convert.ToByte("02", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
            textBox1.Clear();
            textBox1.Text=ReadBuf[0].ToString("x2")+" " + ReadBuf[1].ToString("x2");
            high = (sbyte)ReadBuf[0];
            mvolt = high * 32 + ReadBuf[1] / 32;
            //int mVoutcorr = mvolt * 4095 / (int)numericUpDown3.Value;
            labADCOut.Text = mvolt.ToString("f3") + " V";

        }

        
        private void label12_Click(object sender, EventArgs e)
        {
            WriteBuf[0] = 196; // xC4 auf 8 Bit
            WriteBuf[1] = 0;
            WriteBuf[2] = 0;
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
        }

        private void label13_Click(object sender, EventArgs e)
        {
            WriteBuf[0] = 196; // xC4 auf 8 Bit
            WriteBuf[1] = 3;
            WriteBuf[2] = 255;
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
        }

        private void label14_Click(object sender, EventArgs e)
        {
            textBox2.Text = label14.Text;
            WriteBuf[0] = Convert.ToByte("C4", 16);
            WriteBuf[1] = Convert.ToByte("07", 16);
            WriteBuf[2] = Convert.ToByte("ff", 16);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

  
        }

        private void label15_Click(object sender, EventArgs e)
        {
            textBox2.Text = label15.Text;
            WriteBuf[0] = Convert.ToByte("C4", 16);
            WriteBuf[1] = Convert.ToByte("0b", 16);
            WriteBuf[2] = Convert.ToByte("ff", 16);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }
        
        private void label16_Click(object sender, EventArgs e)
        {
            textBox2.Text = label16.Text;
            WriteBuf[0] = Convert.ToByte("C4", 16);
            WriteBuf[1] = Convert.ToByte("0f", 16);
            WriteBuf[2] = Convert.ToByte("ff", 16);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

        }


        bool sw = true;

        void mmtimerTick(TMultimediaTimer sender)
        {
            // Sample and Hold first read ADC, than output on DAC

            // Rectangle to  DAC

            if (radioButton1.Checked)
            {
                if (sw)
                {
                    WriteBuf[0] = 196;
                    WriteBuf[1] = 0;
                    WriteBuf[2] = 0;
                    CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

                    sw = false;
                }
                else
                {
                    WriteBuf[0] = 196;
                    WriteBuf[1] = 15;
                    WriteBuf[2] = 255;
                    CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);

                    sw = true;
                }
            }
            else   // Sample & Hold
            {
                WriteBuf[0] = Convert.ToByte("93", 16);
                WriteBuf[1] = Convert.ToByte("02", 16);
                CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
                byte high = (byte)ReadBuf[0];
                mvolt = high * 32 + ReadBuf[1] / 32;  // Gesampelter ADC- Wert
                int mVoutcorr = mvolt * 4095 / (int)numericUpDown3.Value;  //Auf 5 V - DAC korrigierter Wert
                WriteBuf[0] = Convert.ToByte("C4", 16);
                byte highout=Convert.ToByte( mVoutcorr / 256);
                WriteBuf[1] =highout; 
                WriteBuf[2] =Convert.ToByte (mVoutcorr-highout*256) ;
                CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
 

            }
           
            
        }

        private void butStartMM_Click(object sender, EventArgs e)
        {
            if (mmtimer.Enabled)
            {
                mmtimer.Enabled = false;
                butStartMM.Text = "Start again";
            }

            else
            {
                mmtimer.Enabled = true;
                butStartMM.Text = "Stop MMTimer";
            }

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            mmtimer.Disable();
            mmtimer.Interval = (uint)numericUpDown1.Value;
            mmtimer.Enable();
        }

        private void butConvAdc_Click(object sender, EventArgs e)
        {
            textBox2.Text = label9.Text;  // ADC auslesen
            WriteBuf[0] = Convert.ToByte("93", 16);
            WriteBuf[1] = Convert.ToByte("02", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);
            textBox1.Text = ReadBuf[0].ToString("x2") + " " + ReadBuf[1].ToString("x2") + "\r\n";
            sbyte high = (sbyte)ReadBuf[0];
            mvolt = high * 32 + ReadBuf[1] / 32;
            //int mVoutcorr = mvolt * 4095 / (int)numericUpDown3.Value;
            labADCOut.Text = mvolt.ToString("f3") + " V";


        }

        private void butInfo_Click(object sender, EventArgs e)
        {
            // needs file "Info.txt" in directory bin/debug of project
            
            StreamReader myStream1 = new StreamReader("Info.txt",Encoding.Default);
            textBox1.Text = myStream1.ReadToEnd();
            myStream1.Close();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            int mVOut = (int)numericUpDown2.Value;
            int mVoutcorr = mVOut * 4095 / (int)numericUpDown3.Value;
            textBox2.Text = "S C4 " + mVoutcorr.ToString("x4");
            
            // Write to DAC
            WriteBuf[0] = Convert.ToByte("C4", 16);
            byte highout = Convert.ToByte(mVoutcorr / 256);
            WriteBuf[1] = highout;
            WriteBuf[2] = Convert.ToByte(mVoutcorr - highout * 256);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
        }

        private void butInitTempADC_Click(object sender, EventArgs e)
        {
            textBox2.Text = " Init Temp and ADC";
            
            WriteBuf[0] = Convert.ToByte("90", 16);  // Init Temp
            WriteBuf[1] = Convert.ToByte("01", 16);
            WriteBuf[2] = Convert.ToByte("60", 16);
            CH341StreamI2C(0, 3, ref WriteBuf[0], 0, ref ReadBuf[0]);
            WriteBuf[1] = Convert.ToByte("90", 16);   // Temp Pointer auf 0, read Temp
            WriteBuf[2] = Convert.ToByte("00", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);

            WriteBuf[0] = Convert.ToByte("92", 16); // Init ADC
            WriteBuf[1] = Convert.ToByte("01", 16);
            WriteBuf[2] = Convert.ToByte("42", 16);
            WriteBuf[3] = Convert.ToByte("e3", 16);
            CH341StreamI2C(0, 4, ref WriteBuf[0], 0, ref ReadBuf[0]);
            WriteBuf[0] = Convert.ToByte("92", 16);   // Adc Pointer 0, read ADC
            WriteBuf[1] = Convert.ToByte("00", 16);
            CH341StreamI2C(0, 2, ref WriteBuf[0], 0, ref ReadBuf[0]);
            butStart1secTimer.Enabled = true;
        }

        private void rB20k_CheckedChanged(object sender, EventArgs e)
        {
            if (rB100k.Checked) CH341SetStream(0, 0x61);
            if (rB20k.Checked)  CH341SetStream(0, 0x60);
            if (rB400k.Checked) CH341SetStream(0, 0x62);
            if (rB750k.Checked) CH341SetStream(0, 0x63);
        }

 
         
    }
}
